/*
    connectionchecksettings.cpp

    Copyright (c) 2009 by Igor 'Sqee' Syromyatnikov <sqee@olimp.ua>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/

#include "connectionchecksettings.h"

// Конструктор
connectioncheckSettings::connectioncheckSettings(const QString &profile_name) 
{
	ui.setupUi(this);
	m_profile_name = profile_name;

	// Обьект для чтения настроек
	QSettings settings(QSettings::IniFormat, QSettings::UserScope, "qutim/qutim."+m_profile_name, "connectioncheck");

	// Читаем и устанавливаем активный элемент в группе кнопок active
        if(settings.value("enabled", true).toBool())
            ui.activeRadio->setChecked(true);
        else
            ui.deactiveRadio->setChecked(true);
        // Читаем период проверки
        ui.periodBox->setValue(settings.value("period",10).toInt());
        ui.routeBox->setChecked(settings.value("routecheck", true).toBool());
        ui.pingBox->setChecked(settings.value("pingcheck", true).toBool());
        ui.nmBox->setChecked(settings.value("nmcheck",true).toBool());
        ui.lEurl->setText(settings.value("pingurl","209.85.129.99").toString());
}

// Деструктор
connectioncheckSettings::~connectioncheckSettings()
{
	
}

// Функция записи настроек в файл
void connectioncheckSettings::saveSettings()
{
	QSettings settings(QSettings::IniFormat, QSettings::UserScope, "qutim/qutim."+m_profile_name, "connectioncheck");
	// Пишем настройки в файл
	settings.setValue("enabled",ui.activeRadio->isChecked());
	settings.setValue("period", ui.periodBox->value());
        settings.setValue("nmcheck",ui.nmBox->isChecked());
        settings.setValue("routecheck", ui.routeBox->isChecked());
        settings.setValue("pingcheck", ui.pingBox->isChecked());
        settings.setValue("pingurl",ui.lEurl->text());
}
